## supercollider 3.4.5

=== common/SConstruct ===
# -*- python -*- =======================================================
# FILE:         SConstruct
# CONTENTS:     scons build script for SuperCollider
# AUTHOR:       sk AT k-hornz DOT de
# modifications: nescivi AT gmail DOT com
# ======================================================================

# ======================================================================
# NOTE: Please use an indentation level of 4 spaces, i.e. no mixing of
# tabs and spaces.
# ======================================================================

# ======================================================================
# setup
# ======================================================================

EnsureSConsVersion(0,96)
EnsurePythonVersion(2,3)
SConsignFile()

# ======================================================================
# imports
# ======================================================================

import glob
import os
import subprocess
import re
import types
import tarfile
import platform   # Seems to have more portable uname() than os

# ======================================================================
# constants
# ======================================================================

PACKAGE = 'SuperCollider'



f = open('../VERSION')
VERSION = f.readline()
f.close()

def short_cpu_name(cpu):
    if cpu == 'Power Macintosh':
        cpu = 'ppc'
    return cpu.lower()

PLATFORM = platform.uname()[0].lower()
CPU = short_cpu_name(platform.uname()[4])

ANY_FILE_RE = re.compile('.*')
HELP_FILE_RE = re.compile('.*\.(rtf(d)?|scd|htm(l)?)$')
SC_FILE_RE = re.compile('.*\.sc$')
SRC_FILE_RE = re.compile('.*\.(c(pp)|h)$')

if PLATFORM == 'darwin':
    PLATFORM_SYMBOL = 'SC_DARWIN'
    PLUGIN_EXT = '.scx'
    DEFAULT_AUDIO_API = 'coreaudio'
    DEFAULT_PREFIX = '/usr/local'
elif PLATFORM == 'freebsd':
    PLATFORM_SYMBOL = 'SC_FREEBSD'
    PLUGIN_EXT = '.so'
    DEFAULT_AUDIO_API = 'jack'
    DEFAULT_PREFIX = '/usr/local'
elif PLATFORM == 'linux':
    PLATFORM_SYMBOL = 'SC_LINUX'
    PLUGIN_EXT = '.so'
    DEFAULT_AUDIO_API = 'jack'
    DEFAULT_PREFIX = '/usr/local'
elif PLATFORM == 'windows':
    PLATFORM_SYMBOL = 'SC_WIN32'
    PLUGIN_EXT = '.scx'
    DEFAULT_AUDIO_API = 'portaudio'
    DEFAULT_PREFIX = '/'
else:
    print 'Unknown platform: %s' % PLATFORM
    Exit(1)

if CPU in [ 'ppc' , 'ppc64' ]:
    DEFAULT_OPT_ARCH = '7450'
elif CPU in [ 'i586', 'i686' ]:
    # FIXME: better detection
    DEFAULT_OPT_ARCH = CPU
else:
    DEFAULT_OPT_ARCH = None

if PLATFORM != 'windows':
	subprocess.call(['sh', 'setMainVersion.sh'])


# ======================================================================
# util
# ======================================================================


def make_os_env(*keys):
    env = os.environ
    res = {}
    for key in keys:
        if env.has_key(key):
            res[key] = env[key]
    return res

def CheckPKGConfig(context, version):
    context.Message( 'Checking for pkg-config... ' )
    ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0]
    context.Result( ret )
    return ret

def CheckPKG(context, name):
    context.Message('Checking for %s... ' % name)
    ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
    res = None
    if ret:
        res = Environment(ENV = make_os_env('PATH', 'PKG_CONFIG_PATH'))
        res.ParseConfig('pkg-config --cflags --libs \'%s\'' % name)
        res['PKGCONFIG'] = name
    context.Result(ret)
    return (ret, res)

def get_new_pkg_env():
    return Environment(ENV = make_os_env('PATH', 'PKG_CONFIG_PATH'))

def merge_lib_info(env, *others):
    for other in others:
        env.AppendUnique(CCFLAGS = other.get('CCFLAGS', []))
        env.AppendUnique(CPPDEFINES = other.get('CPPDEFINES', []))
        env.AppendUnique(CPPPATH = other.get('CPPPATH', []))
        env.AppendUnique(CXXFLAGS = other.get('CXXFLAGS', []))
        env.AppendUnique(LIBS = other.get('LIBS', []))
        env.AppendUnique(LIBPATH = other.get('LIBPATH', []))
        env['LINKFLAGS'] = env['LINKFLAGS'] + other.get('LINKFLAGS', "")

def make_pkgconfig_requires(*envs):
    res = []
    for env in envs:
        if env and env.has_key('PKGCONFIG'):
            res.append(env['PKGCONFIG'])
    return res

def build_pkgconfig_file(target, source, env):
    def write_field(file, name, prefix, separator=None):
        if env.has_key(name):
            if separator:
                content = separator.join(env[name])
            else:
                content = env[name]
            file.write('%s%s\n' % (prefix, content))
    out = file(str(target[0]), 'w')
    out.writelines([
        'prefix=%s\n' % env['PREFIX'],
        'exec_prefix=${prefix}\n',
        'libdir=${exec_prefix}/lib\n',
        'includedir=${prefix}/include/%s\n' % env['PACKAGE'],
        '\n'])
    write_field(out, 'PKGCONFIG_NAME', 'Name: ')
    write_field(out, 'PKGCONFIG_DESC', 'Description: ')
    write_field(out, 'URL', 'URL: ')
    write_field(out, 'VERSION', 'Version: ')
    write_field(out, 'PKGCONFIG_REQUIRES', 'Requires: ', ', ')
    write_field(out, 'PKGCONFIG_REQUIRES_PRIVATE', 'Requires.private: ', ', ')
    write_field(out, 'PKGCONFIG_LIBS', 'Libs: -L${libdir} ', ' ')
    write_field(out, 'PKGCONFIG_LIBS_PRIVATE', 'Libs.private: ', ' ')
    write_field(out, 'PKGCONFIG_CFLAGS', 'Cflags: ', ' ')
    out.close()

def flatten_dir(dir):
    res = []
    for root, dirs, files in os.walk(dir):
        if 'CVS' in dirs: dirs.remove('CVS')
        if '.svn' in dirs: dirs.remove('.svn')
        for f in files:
            res.append(os.path.join(root, f))
    return res

def install_dir(env, src_dir, dst_dir, filter_re, strip_levels=0):
    nodes = []
    for root, dirs, files in os.walk(src_dir):
        src_paths = []
        dst_paths = []
        if 'CVS' in dirs: dirs.remove('CVS')
        if '.svn' in dirs: dirs.remove('.svn')
        for d in dirs[:]:
            if filter_re.match(d):
                src_paths += flatten_dir(os.path.join(root, d))
                dirs.remove(d)
        for f in files:
            if filter_re.match(f):
                src_paths.append(os.path.join(root, f))
        dst_paths += map(
            lambda f:
            os.path.join(
            dst_dir,
            *f.split(os.path.sep)[strip_levels:]),
            src_paths)
        nodes += env.InstallAs(dst_paths, src_paths)
    return nodes

def is_installing():
    pat = re.compile('^install.*$')
    for x in COMMAND_LINE_TARGETS:
        if pat.match(x): return True
    return False

def is_home_directory(dir):
    return os.path.normpath(dir) == os.path.normpath(os.environ.get('HOME', '/'))

def bin_dir(prefix):
    return os.path.join(prefix, 'bin')
def lib_dir(prefix):
    return os.path.join(prefix, 'lib')

def pkg_data_dir(prefix, *args):
    if PLATFORM == 'darwin':
        base = '/Library/Application Support'
        if is_home_directory(prefix):
            base = os.path.join(prefix, base)
    else:
        base = os.path.join(prefix, 'share')
    return os.path.join(base, PACKAGE, *args)
def pkg_doc_dir(prefix, *args):
    if PLATFORM == 'darwin':
        base = '/Library/Documentation'
        if is_home_directory(prefix):
            base = os.path.join(prefix, base)
    else:
        base = os.path.join(prefix, 'share', 'doc')
    return os.path.join(base, PACKAGE, *args)
def pkg_include_dir(prefix, *args):
    return os.path.join(prefix, 'include', PACKAGE, *args)
def pkg_lib_dir(prefix, *args):
    return os.path.join(lib_dir(prefix), PACKAGE, *args)

def pkg_classlib_dir(prefix, *args):
    return pkg_data_dir(prefix, 'SCClassLibrary', *args)
def pkg_extension_dir(prefix, *args):
    return pkg_data_dir(prefix, 'Extensions', *args)

def make_opt_flags(env):
    flags = [
        "-O3",
        ## "-fomit-frame-pointer", # can behave strangely for sclang
        "-ffast-math",
        "-fno-finite-math-only",
        "-fstrength-reduce"
        ]
    arch = env.get('OPT_ARCH')
    if arch:
        if CPU in [ 'ppc' , 'ppc64' ]:
            flags.extend([ "-mcpu=%s" % (arch,) ])
        else:
            flags.extend([ "-march=%s" % (arch,) ])
    if CPU in [ 'ppc' , 'ppc64' ]:
        flags.extend([ "-fsigned-char", "-mhard-float",
                       ## "-mpowerpc-gpopt", # crashes sqrt
                       "-mpowerpc-gfxopt"
                       ])
    return flags

def make_static_object(env, source, postfix="_a"):
    obj = os.path.splitext(source)[0] + postfix
    return env.StaticObject(obj, source)

def make_static_objects(env, sources, postfix="_a"):
    return map(lambda x: make_static_object(env, x, postfix), sources)

# for linking libX.so => libX.so.1 on *nixy systems. Note, they must be in same dir.
def make_local_symlink(target, source, env):
    targetname = os.path.basename(str(target[0]))
    if os.path.isfile(targetname):
        if not os.path.islink(targetname):
            liblog.error("ERROR: cannot create symlink %s because already exists as non-symlink." % (targetname))
    else:
	    os.symlink(os.path.basename(str(source[0])), targetname)
    return None

# for linking libX.so => libX.so.1 on *nixy systems. Note, they must be in same dir.
def make_local_symlink(target, source, env):
    targetname = os.path.basename(str(target[0]))
    if os.path.isfile(targetname):
        if not os.path.islink(targetname):
            liblog.error("ERROR: cannot create symlink %s because already exists as non-symlink." % (targetname))
    else:
	    os.symlink(os.path.basename(str(source[0])), targetname)
    return None

# ======================================================================
# command line options
# ======================================================================

opts = Options('scache.conf', ARGUMENTS)
opts.AddOptions(
    BoolOption('ALSA',
               'Build with ALSA sequencer support', 1),
    BoolOption('ALTIVEC',
               'Build with Altivec support', 1),
    ('OPT_ARCH', 'Architecture to optimize for', DEFAULT_OPT_ARCH),
    EnumOption('AUDIOAPI',
               'Build with specified audio API support',
               DEFAULT_AUDIO_API, ('jack', 'coreaudio', 'portaudio')),
    ('CC', 'C compiler executable'),
    ('CCFLAGS', 'C compiler flags'),
    ('CXX', 'C++ compiler executable'),
    ('CXXFLAGS', 'C++ compiler flags'),
    BoolOption('DEBUG',
               'Build with debugging information', 0),
    PathOption('DESTDIR',
               'Intermediate installation prefix for packaging', '/',
               PathOption.PathAccept),
    BoolOption('DEVELOPMENT',
               'Build and install the development files', 0),
    BoolOption('FFTW',
               'Use the FFTW libraries', PLATFORM != 'darwin'),
    BoolOption('JACK_DLL',
               'Build with delay locked loop support', 0),
    BoolOption('JACK_DEBUG_DLL',
               'Build with delay locked loop debugging support', 0),
    BoolOption('LANG',
               'Build the language application', 1),
    BoolOption('LID',
               'Build with Linux Input Device support [linux]', PLATFORM == 'linux'),
    BoolOption('NO_LIBSNDFILE',
               'Disable libsndfile (audio file reading/writing)', 0),
    BoolOption('WII',
               'Build with Linux WII support [linux]', PLATFORM == 'linux'),
    PathOption('PREFIX',
               'Installation prefix', DEFAULT_PREFIX),
    BoolOption('RENDEZVOUS',
               'Enable Zeroconf/Rendezvous.', 1),
    BoolOption('SCEL',
               'Enable the SCEL user interface; NOTE for the HTML help system you need emacs-w3m', 1),
    BoolOption('SCVIM',
               'Enable the SCVIM user interface; NOTE see the README in /editors/scvim for setting variables', 1),
    BoolOption('SCED',
               'Enable the SCED (based on gedit) user interface; NOTE see the README in /editors/sced for setting variables', 0),
    BoolOption('SSE',
               'Build with SSE support', 1),
    BoolOption('SSE2',

=== common/wscript ===
#! /usr/bin/env python
# encoding: utf-8

# =====================================================================
# Experimental waf build script for SuperCollider, currently Linux-only
# use with caution!!
# --artfwo

import os
import sys

VERSION='3.3.1'   # TODO: grab the version from the VERSION file, as in the SConstruct
APPNAME='supercollider'
srcdir = '.'
blddir = 'build/waf' # FIXME

SC3_API_VERSION=VERSION

def set_options(opt):
    opt.tool_options('gnu_dirs')
    opt.tool_options('compiler_cc')
    opt.tool_options('compiler_cxx')

def configure(conf):
    import Utils
    platform = Utils.detect_platform()

    conf.env['IS_LINUX'] = platform == 'linux'
    conf.env['IS_WIN32'] = platform == 'win32'
    conf.env['IS_MACOSX'] = platform == 'darwin'
    conf.env['IS_FREEBSD'] = platform == 'freebsd'

    if not conf.env['IS_LINUX']:
        Utils.pprint('RED', 'Sorry, waf builder currently does not work on %s platform!' % platform)
        sys.exit(1)

    conf.check_tool('gnu_dirs')
    conf.check_tool('compiler_cc')
    conf.check_tool('compiler_cxx')
    #conf.check_tool('misc')

    conf.check_cfg(atleast_pkgconfig_version='0.0.0')

    conf.check_cfg(package='sndfile', atleast_version='1.0.16',
        args='--cflags --libs', mandatory=True)
    conf.check_cfg(package='jack', atleast_version='0.100',
        args='--cflags --libs', mandatory=True)
    conf.check_cfg(package='avahi-client',
        args='--cflags --libs', mandatory=True)
    conf.check_cfg(package='alsa',
        args='--cflags --libs', mandatory=True)
    conf.check_cfg(package='xt',
        args='--cflags --libs', mandatory=True)
    conf.check_cfg(package='fftw3f',
        args='--cflags --libs', mandatory=True)

    conf.check_cc(header_name='cwiid.h', lib='cwiid', uselib_store='CWIID')
    conf.check_cc(header_name='linux/input.h')
    conf.check_cc(header_name='xmmintrin.h', ccflags=['-msse', '-mfpmath=sse'], define_name='HAVE_SSE')

    if conf.env['HAVE_SSE']:
        conf.env.append_unique('CCFLAGS', ['-msse', '-mfpmath=sse'])
        conf.env.append_unique('CXXFLAGS', ['-msse', '-mfpmath=sse'])
        conf.define('SC_MEMORY_ALIGNMENT', 16)
    else:
        conf.define('SC_MEMORY_ALIGNMENT', 1)

    #conf.env['LIBDIR'] = os.path.join(conf.env['PREFIX'], 'lib')
    #conf.env['DATADIR'] = os.path.join(conf.env['PREFIX'], 'share')

    # global defines
    conf.define('HAVE_ALSA', 1)
    conf.define('HAVE_AVAHI', 1)
    conf.define('HAVE_LID', 1)
    conf.define('HAVE_WII', 1)
    #conf.define('SC_AUDIO_API=SC_AUDIO_API_JACK')
    conf.define('SC_FFT_FFTW', 1)
    conf.define('SC_LINUX', 1)
    #conf.define('SC_MEMORY_ALIGNMENT', 16)
    conf.define('SC_USE_JACK_CLIENT_NEW', 1)
    conf.define('USE_RENDEZVOUS', 1)
    conf.define('USE_SC_TERMINAL_CLIENT', 1)

    conf.define('SC_DATA_DIR', os.path.join(conf.env['DATADIR'], 'SuperCollider'))
    conf.define('SC_PLUGIN_DIR', os.path.join(conf.env['LIBDIR'], 'SuperCollider', 'plugins'))
    conf.define('SC_PLUGIN_EXT', '.so')
    conf.define('SC_PLUGIN_LOAD_SYM', 'load')

    # other defines from SConstruct
    conf.env.append_unique('CCFLAGS', ['-Wno-unknown-pragmas'])
    conf.env.append_unique('CXXFLAGS', ['-Wno-unknown-pragmas', '-Wno-deprecated'])

    # FIXME: ugly hack but SC3 does not use config.h now
    conf.env.append_value('CPPFLAGS', ['-include','default/waf_config.h'])
    conf.write_config_header('waf_config.h')

def sc_plugin_gen(bld, name, source, uselib='', add_objects=[]):
    obj = bld.new_task_gen('cxx', 'shlib')
    obj.add_objects = add_objects
    obj.env['shlib_PATTERN'] = '%s.so'
    obj.includes = '#Headers/common #Headers/plugin_interface #Headers/server'
    obj.install_path = '${SC_PLUGIN_DIR}/'
    obj.source = source
    obj.target = name
    obj.uselib = uselib
    return obj

def build(bld):
    # objects for other targets
    fftlib = bld.new_task_gen('cc')
    fftlib.includes = '#Headers/common'
    fftlib.source = 'Source/common/fftlib.c'
    fftlib.target = 'fftlib'

    # libcommon
    libcommon = bld.new_task_gen('cxx', 'staticlib')
    libcommon.includes = '#Headers/common #Headers/plugin_interface #Headers/server'
    libcommon.source = [
        'Source/common/SC_AllocPool.cpp',
        'Source/common/SC_DirUtils.cpp',
        'Source/common/sc_popen.cpp',
        'Source/common/SC_Sem.cpp',
        'Source/common/SC_StringBuffer.cpp',
        'Source/common/SC_StringParser.cpp',
        'Source/common/scsynthsend.cpp',
    ] # libcommon_source
    libcommon.target = 'common'
    libcommon.install_path = None

    # libscsynth
    libscsynth = bld.new_task_gen('cxx', 'shlib')
    # FIXME: AUDIOAPI -> top
    libscsynth.defines = 'SC_AUDIO_API=SC_AUDIO_API_JACK'
    libscsynth.includes = '#Headers/common #Headers/plugin_interface #Headers/server'
    libscsynth.uselib = 'JACK SNDFILE AVAHI-CLIENT' # FIXME
    libscsynth.uselib_local = 'common'
    libscsynth.vnum = SC3_API_VERSION # FIXME
    libscsynth.source = [
        'Source/server/Rendezvous.cpp',
        'Source/server/Samp.cpp',
        'Source/server/SC_BufGen.cpp',
        'Source/server/SC_Carbon.cpp',
        'Source/server/SC_Complex.cpp',
        'Source/server/SC_ComPort.cpp',
        'Source/server/SC_CoreAudio.cpp',
        'Source/server/SC_Errors.cpp',
        'Source/server/SC_Graph.cpp',
        'Source/server/SC_GraphDef.cpp',
        'Source/server/SC_Group.cpp',
        'Source/server/SC_Lib_Cintf.cpp',
        'Source/server/SC_Lib.cpp',
        'Source/server/SC_MiscCmds.cpp',
        'Source/server/SC_Node.cpp',
        'Source/server/SC_Rate.cpp',
        'Source/server/SC_SequencedCommand.cpp',
        'Source/server/SC_Str4.cpp',
        'Source/server/SC_SyncCondition.cpp',
        'Source/server/SC_Unit.cpp',
        'Source/server/SC_UnitDef.cpp',
        'Source/server/SC_World.cpp',
        # FIXME:
        'Source/server/SC_Jack.cpp',
    ] # libscsynth_source
    libscsynth.target = 'scsynth'

    #uselib_local = 'my_static_lib',

    scsynth = bld.new_task_gen('cxx', 'program')
    #scsynth.defines = sc3_defines
    scsynth.includes = '#Headers/common #Headers/plugin_interface #Headers/server'
    scsynth.source = ['Source/server/scsynth_main.cpp'] #+ common_sources
    scsynth.target = 'scsynth'
    scsynth.uselib_local = 'scsynth' # FIXME
    #scsynth.uselib = ['JACK']

    # libsclang
    libsclang = bld.new_task_gen('cxx', 'shlib')
    #libsclang.defines = sc3_defines
    libsclang.includes = '#Headers/common #Headers/plugin_interface #Headers/lang #Source/lang/LangSource/Bison'
    libsclang.target = 'sclang'
    libsclang.uselib_local = 'common'
    libsclang.uselib = 'SNDFILE CWIID ALSA'
    libsclang.vnum = SC3_API_VERSION # FIXME
    libsclang.source = [
        'Source/lang/LangPrimSource/OSCData.cpp',
        'Source/lang/LangPrimSource/PyrArchiver.cpp',
        'Source/lang/LangPrimSource/PyrArrayPrimitives.cpp',
        'Source/lang/LangPrimSource/PyrBitPrim.cpp',
        'Source/lang/LangPrimSource/PyrCharPrim.cpp',
        'Source/lang/LangPrimSource/PyrFilePrim.cpp',
        'Source/lang/LangPrimSource/PyrListPrim.cpp',
        'Source/lang/LangPrimSource/PyrMathPrim.cpp',
        'Source/lang/LangPrimSource/PyrPlatformPrim.cpp',
        'Source/lang/LangPrimSource/PyrPrimitive.cpp',
        'Source/lang/LangPrimSource/PyrSched.cpp',
        'Source/lang/LangPrimSource/PyrSerialPrim.cpp',
        'Source/lang/LangPrimSource/PyrSignalPrim.cpp',
        'Source/lang/LangPrimSource/PyrStringPrim.cpp',
        'Source/lang/LangPrimSource/PyrSymbolPrim.cpp',
        'Source/lang/LangPrimSource/PyrUnixPrim.cpp',
        'Source/lang/LangPrimSource/PyrUStringPrim.cpp',
        'Source/lang/LangPrimSource/SC_ComPort.cpp',
        'Source/lang/LangPrimSource/SC_Wii.cpp',
        'Source/lang/LangSource/AdvancingAllocPool.cpp',
        'Source/lang/LangSource/alloca.cpp',
        'Source/lang/LangSource/Bison/lang11d_tab.cpp',
        'Source/lang/LangSource/ByteCodeArray.cpp',
        'Source/lang/LangSource/dumpByteCodes.cpp',
        'Source/lang/LangSource/DumpParseNode.cpp',
        'Source/lang/LangSource/GC.cpp',
        'Source/lang/LangSource/InitAlloc.cpp',
        'Source/lang/LangSource/PyrFileUtils.cpp',
        'Source/lang/LangSource/PyrInterpreter3.cpp',
        'Source/lang/LangSource/PyrLexer.cpp',
        'Source/lang/LangSource/PyrMathOps.cpp',
        'Source/lang/LangSource/PyrMathSupport.cpp',
        'Source/lang/LangSource/PyrMessage.cpp',
        'Source/lang/LangSource/PyrObject.cpp',
        'Source/lang/LangSource/PyrParseNode.cpp',
        'Source/lang/LangSource/PyrSignal.cpp',
        'Source/lang/LangSource/PyrSymbolTable.cpp',
        'Source/lang/LangSource/Samp.cpp',
        'Source/lang/LangSource/SC_LanguageClient.cpp',
        'Source/lang/LangSource/SC_LibraryConfig.cpp',
        'Source/lang/LangSource/SC_TerminalClient.cpp',
        'Source/lang/LangSource/SimpleStack.cpp',
        'Source/lang/LangSource/VMGlobals.cpp',
        # FIXME:
        #'Source/common/fftlib.c',
        'Source/lang/LangPrimSource/SC_LID.cpp',
        'Source/lang/LangPrimSource/SC_AlsaMIDI.cpp',
    ] # libsclang_source
    libsclang.add_objects = 'fftlib' # FIXME

    # sclang
    sclang = bld.new_task_gen('cxx', 'program')
    sclang.includes = '#Headers/lang #Headers/plugin_interface #Headers/common'
    sclang.source = ['Source/lang/LangSource/cmdLineFuncs.cpp'] #+ common_sources
    sclang.target = 'sclang'
    sclang.uselib_local = 'sclang scsynth'

    # plugins
    sccomplex = bld.new_task_gen('cxx')
    sccomplex.includes = '#Headers/common #Headers/plugin_interface #Headers/server'
    sccomplex.source = 'Source/plugins/SCComplex.cpp'
    sccomplex.target = 'SCComplex'

    stdugens = [
        'BinaryOpUGens',
        'ChaosUGens',
        'DelayUGens',
        'DemandUGens',
        'DynNoiseUGens',
        'FilterUGens',
        'GendynUGens',
        'IOUGens',
        'LFUGens',
        'MulAddUGens',
        'NoiseUGens',
        'OscUGens',
        'PanUGens',
        'PhysicalModelingUGens',
        'TestUGens',
        'TriggerUGens',
        'UnaryOpUGens',
        'GrainUGens',
        'ReverbUGens'
    ] # ugens
    for name in stdugens:
        sc_plugin_gen(bld, name, source=os.path.join('Source', 'plugins', name + '.cpp'))

    sc_plugin_gen(bld, 'FFTUgens', source=[
        'Source/plugins/FFTInterfaceTable.cpp',
        'Source/plugins/FFT_UGens.cpp',
        'Source/plugins/PV_UGens.cpp',
        'Source/plugins/PartitionedConvolution.cpp',
        'Source/common/SC_fftlib.cpp'], # XXX: special inline
        uselib='FFTW3F',
        add_objects='SCComplex')

    sc_plugin_gen(bld, 'PVThirdParty', source=[
        'Source/plugins/Convolution.cpp',
        'Source/plugins/FFT2InterfaceTable.cpp',
        'Source/plugins/FeatureDetection.cpp',
        'Source/plugins/PV_ThirdParty.cpp',
        'Source/common/SC_fftlib.cpp'], # XXX: special inline
        uselib='FFTW3F',
        add_objects='SCComplex')

    sc_plugin_gen(bld, 'UnpackFFTUGens', source=[
        'Source/plugins/UnpackFFTUGens.cpp'],
        add_objects='SCComplex')

    sc_plugin_gen(bld, 'MLUgens', source=[
        'Source/plugins/ML.cpp',
        'Source/plugins/Loudness.cpp',
        'Source/plugins/BeatTrack.cpp',
        'Source/plugins/Onsets.cpp',
        'Source/plugins/onsetsds.c',
        'Source/plugins/KeyTrack.cpp',
        'Source/plugins/MFCC.cpp',
        'Source/plugins/BeatTrack2.cpp',
        'Source/plugins/ML_SpecStats.cpp'],
        add_objects='SCComplex')

    sc_plugin_gen(bld, 'DiskIOUgens', source=[
        'Source/server/SC_SyncCondition.cpp',
        'Source/plugins/DiskIO_UGens.cpp'])

    sc_plugin_gen(bld, 'MouseUGens',
        source=os.path.join('Source', 'plugins', 'MouseUGens.cpp'),
        uselib='XT')
    sc_plugin_gen(bld, 'KeyboardUGens',
        source=os.path.join('Source', 'plugins', 'KeyboardUGens.cpp'),
        uselib='XT')

=== editors/sced/SConstruct ===
# -*- python -*- =======================================================
# FILE:         SConstruct
# CONTENTS:     scons build script for scved
# AUTHOR:       nesciv AT gmail DOT com
# AUTHOR:       alex AT x37v DOT info (followed the example of scvim)
# AUTHOR:       sk AT k-hornz DOT de (some of this SConstruct taken from sk's SConstruct for SuperCollider)
# ======================================================================

import os
import re
import pwd

PLATFORM = os.uname()[0].lower()

SC_FILE_RE = re.compile('.*\.sc$')

PY_FILE_RE = re.compile('.*\.py$')
LANG_FILE_RE = re.compile('.*\.lang$')
XML_FILE_RE = re.compile('.*\.xml$')
PLUGIN_FILE_RE = re.compile('.*\.gedit-plugin$')

ANY_FILE_RE = re.compile('.*')
HOME_DIR_RE = re.compile(os.environ.get('HOME') + '.*')

DEFAULT_PREFIX = '/usr/local/'
#DEFAULT_SC_HELP = os.path.join(DEFAULT_PREFIX, 'share/SuperCollider/Help/')


def pkg_data_dir(prefix, *args):
    if PLATFORM == 'darwin':
        base = '/Library/Application Support'
        if is_home_directory(prefix):
            base = os.path.join(prefix, base)
    else:
        base = os.path.join(prefix, 'share')
    return os.path.join(base, 'SuperCollider', *args)

def pkg_extension_dir(prefix, *args):
    return pkg_data_dir(prefix, 'Extensions', *args)

SWAP_FILE_MATCH = re.compile('.*.swp')

def install_dir(env, src_dir, dst_dir, filter_re, strip_levels=0):
    nodes = []
    for root, dirs, files in os.walk(src_dir):
        src_paths = []
        dst_paths = []
        if 'CVS' in dirs: dirs.remove('CVS')
        if '.svn' in dirs: dirs.remove('.svn')
        for d in dirs[:]:
            if filter_re.match(d):
                src_paths += flatten_dir(os.path.join(root, d))
                dirs.remove(d)
        for f in files:
			  #ditch swap files
            if not SWAP_FILE_MATCH.match(f) and filter_re.match(f):
                src_paths.append(os.path.join(root, f))
        dst_paths += map(
            lambda f:
            os.path.join(
            dst_dir,
            *f.split(os.path.sep)[strip_levels:]),
            src_paths)
        nodes += env.InstallAs(dst_paths, src_paths)
    return nodes

#def install_file(env, src_file, dst_dir, strip_levels=0):
    #nodes = []
    #dst_path = map(
        #lambda f:
        #os.path.join(
        #dst_dir,
        #*f.split(os.path.sep)[strip_levels:])
		#,src_file)
    #nodes += env.InstallAs(dst_path, src_file)
    #print src_file
    #print nodes
    #return nodes

def bin_dir(prefix):
    return os.path.join(prefix, 'bin')

def lib_dir(prefix):
    return os.path.join(prefix, 'lib')

def share_dir(prefix):
    return os.path.join(prefix, 'share')

def in_home_directory(dir):
	return HOME_DIR_RE.match(dir)

##build help, the help depends on having the home directory enviroment variable.. that could change
#build_help = Builder(action =
		#'export HOME=' + os.environ.get('HOME') + ' && ruby ' + os.getcwd() + '/bin/scvim_make_help -f -s $SOURCE -d $TARGET')

#create our options
opts = Options()
opts.Add(PathOption('PREFIX', 'Specify the prefix for the bin and share files',
	DEFAULT_PREFIX, PathOption.PathIsDir))

#create our enviroment, with our options and custom builders
env = Environment(options = opts)
#, BUILDERS = {'BuildHelp' : build_help})

#generate the help options
Help(opts.GenerateHelpText(env))


#get our variables from the options
PREFIX = env.get('PREFIX')

install_scedfiles = env.Alias('install-scedfiles', [
	#install_file( env, 'data/supercollider.lang', os.path.join( share_dir(PREFIX), 'gtksourceview-2.0/language-specs' ), 0 ),
	#install_file( env, 'data/supercollider.xml', os.path.join( share_dir(PREFIX), 'mime/packages' ), 0 ),
	#install_file( env, 'data/sced.gedit-plugin', os.path.join( lib_dir(PREFIX), 'gedit-2/plugins' ), 0 ),
	install_dir( env, 'data/', os.path.join( share_dir(PREFIX), 'gtksourceview-2.0/language-specs' ), LANG_FILE_RE, 1 ),
	install_dir( env, 'data/', os.path.join( share_dir(PREFIX), 'mime/packages' ), XML_FILE_RE, 1 ),
	install_dir( env, 'data/', os.path.join( lib_dir(PREFIX), 'gedit-2/plugins' ), PLUGIN_FILE_RE, 1 ),
	install_dir( env, 'sced/', os.path.join( lib_dir(PREFIX), 'gedit-2/plugins' ), PY_FILE_RE, 0 )
	])


update_mime = Builder(action =
		'update-mime-database ' + os.path.join( share_dir(PREFIX), 'mime/packages' ) )

env.BUILDERS = update_mime

#install_doc = env.Alias('install-doc', env.Install(DOC_DIR, ['SCVim.scd']))
#build_help = env.Alias('build-help', env.BuildHelp(target = Dir(DOC_DIR),
	#source = Dir(SUPERCOLLIDER_HELP_DIR)))
#AlwaysBuild(Dir(DOC_DIR))
#Depends(build_help, install_doc)

env.Alias('install', [
	install_scedfiles,
])

#this should be commonly run by the user who wishes to use it if the CACHE_DIR
# and VIMFILE_DIR is in the user's homedir
#env.Alias('install-user', [install_vimfiles, install_doc])
#this should normally be run with sudo privileges
#env.Alias('install-system', [install_bin, install_rc, install_classes])

#for x in env.Glob('*', ondisk = False, strings = False, source = False):
#	print x.get_abspath()

=== editors/scvim/SConstruct ===
# -*- python -*- =======================================================
# FILE:         SConstruct
# CONTENTS:     scons build script for scvim
# AUTHOR:       alex AT x37v DOT info
# AUTHOR:       sk AT k-hornz DOT de (some of this SConstruct taken from sk's SConstruct for SuperCollider)
# ======================================================================

import os
import re
import pwd

PLATFORM = os.uname()[0].lower()

SC_FILE_RE = re.compile('.*\.sc$')
VIM_FILE_RE = re.compile('.*\.vim$')
ANY_FILE_RE = re.compile('.*')
HOME_DIR_RE = re.compile(os.environ.get('HOME') + '.*')

DEFAULT_PREFIX = '/usr/local/'

if os.path.isdir(os.path.join(DEFAULT_PREFIX, 'share/SuperCollider/Help/')):
	DEFAULT_SC_HELP = os.path.join(DEFAULT_PREFIX, 'share/SuperCollider/Help/')
elif os.path.isdir('../../common/build/Help/'):
	DEFAULT_SC_HELP = '../../common/build/Help/'
else:
	DEFAULT_SC_HELP = os.path.join(DEFAULT_PREFIX, 'share/SuperCollider/Help/')

def in_home_directory(dir):
	return HOME_DIR_RE.match(dir)

def pkg_data_dir(prefix, *args):
    if PLATFORM == 'darwin':
        base = '/Library/Application Support'
        if in_home_directory(prefix):
            base = os.path.join(prefix, base)
    else:
        base = os.path.join(prefix, 'share')
    return os.path.join(base, 'SuperCollider', *args)

def pkg_extension_dir(prefix, *args):
    return pkg_data_dir(prefix, 'Extensions', *args)

SWAP_FILE_MATCH = re.compile('.*.swp')

def install_dir(env, src_dir, dst_dir, filter_re, strip_levels=0):
    nodes = []
    for root, dirs, files in os.walk(src_dir):
        src_paths = []
        dst_paths = []
        if 'CVS' in dirs: dirs.remove('CVS')
        if '.svn' in dirs: dirs.remove('.svn')
        for d in dirs[:]:
            if filter_re.match(d):
                src_paths += flatten_dir(os.path.join(root, d))
                dirs.remove(d)
        for f in files:
			  #ditch swap files
            if not SWAP_FILE_MATCH.match(f) and filter_re.match(f):
                src_paths.append(os.path.join(root, f))
        dst_paths += map(
            lambda f:
            os.path.join(
            dst_dir,
            *f.split(os.path.sep)[strip_levels:]),
            src_paths)
        nodes += env.InstallAs(dst_paths, src_paths)
    return nodes

def bin_dir(prefix):
    return os.path.join(prefix, 'bin')

def share_dir(prefix):
    return os.path.join(prefix, 'share')

#build help, the help depends on having the home directory enviroment variable.. that could change
build_help = Builder(action =
		'export HOME=' + os.environ.get('HOME') + ' && ruby ' + os.getcwd() + '/bin/scvim_make_help -f -s $SOURCE -d $TARGET')

#create our options
opts = Options()
opts.Add(PathOption('PREFIX', 'Specify the prefix for the bin and share files',
	DEFAULT_PREFIX, PathOption.PathIsDir))
opts.Add(PathOption('CACHE_DIR',
		'Specify the dir for scvim help docs, syntax highlighting, etc',
		os.path.join(os.environ.get('HOME', '/'), '.scvim/'), PathOption.PathAccept))
opts.Add(PathOption('VIMFILE_DIR',
		'Specify the dir for vim files, these need to be in vim\'s runtime path',
		os.path.join(os.environ.get('HOME', '/'), '.vim/'), PathOption.PathAccept))
opts.Add(PathOption('SUPERCOLLIDER_HELP_DIR',
	'Specify the location of SuperCollider\'s help',
	DEFAULT_SC_HELP, PathOption.PathIsDir))

#create our enviroment, with our options and custom builders
env = Environment(options = opts, BUILDERS = {'BuildHelp' : build_help})


#generate the help options
Help(opts.GenerateHelpText(env))

#XXX how do we test for vim?
if not env.GetOption('clean'):
	#test for the ruby
	if os.system("ruby -e exit") != 0:
		print "error: scvim depends on ruby and the ruby executable is not in your path"
		Exit(1)

#get our variables from the options
PREFIX = env.get('PREFIX')
VIMFILE_DIR = env.get('VIMFILE_DIR')
CACHE_DIR = env.get('CACHE_DIR')
SUPERCOLLIDER_HELP_DIR = env.get('SUPERCOLLIDER_HELP_DIR')
DOC_DIR = os.path.join(CACHE_DIR, 'doc/')

#install_from_base = env.Alias('install-from-base',[
	#Import( 'vimenv' ),
	#print vimenv],
	#)

install_vimfiles = env.Alias('install-vimfiles', [
	install_dir( env, 'ftplugin', VIMFILE_DIR, VIM_FILE_RE, 0),
	install_dir( env, 'syntax', VIMFILE_DIR, VIM_FILE_RE, 0),
	install_dir( env, 'indent', VIMFILE_DIR, VIM_FILE_RE, 0)],
	#could chown here, if in user's homedir?
	)

install_doc = env.Alias('install-doc', env.Install(DOC_DIR, ['SCVim.scd']))
build_help = env.Alias('build-help', env.BuildHelp(target = Dir(DOC_DIR),
	source = Dir(SUPERCOLLIDER_HELP_DIR)))
AlwaysBuild(Dir(DOC_DIR))
Depends(build_help, install_doc)

install_bin = env.Alias('install-bin',
		install_dir(env, 'bin', bin_dir(PREFIX), ANY_FILE_RE, 1))

install_rc = env.Alias('install-rc', env.Install(os.path.join(share_dir(PREFIX), 'scvim/'), ['scvimrc']))

install_classes = env.Alias('install-classes', install_dir(
   env, 'scclasses',
   pkg_extension_dir(PREFIX, 'scvim'),
   SC_FILE_RE, 1))

env.Alias('install-all', [
	install_bin,
	install_vimfiles,
	install_doc,
	install_rc,
	install_classes])

#this should be commonly run by the user who wishes to use it if the CACHE_DIR
# and VIMFILE_DIR is in the user's homedir
env.Alias('install-user', [install_vimfiles, install_doc])
#this should normally be run with sudo privileges
env.Alias('install-system', [install_bin, install_rc, install_classes])

#called from main script
#env.Alias('install', [install_from_base])

#print env['install']

#for x in env.Glob('*', ondisk = False, strings = False, source = False):
#	print x.get_abspath()


# ======================================================================
# configuration summary
# ======================================================================

#def yesorno(p):
    #if p: return 'yes'
    #else: return 'no'

#print '------------------------------------------------------------------------'
#print 'PREFIX                 :' PREFIX
#print 'CACHE_DIR              :' CACHE_DIR
#print 'VIMFILE_DIR            :' VIMFILE_DIR
#print 'DOC_DIR                :' DOC_DIR
#print 'SUPERCOLLIDER_HELP_DIR :' SUPERCOLLIDER_HELP_DIR
#print '------------------------------------------------------------------------'

# ======================================================================
# EOF

=== common/include/nova-simd/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (nova-simd)

enable_testing()

add_subdirectory (benchmarks)
add_subdirectory (testsuite)

=== common/include/nova-simd/benchmarks/CMakeLists.txt ===
set(benchmarks
  abs_benchmarks.cpp
  clear_benchmark.cpp
  clip_benchmarks.cpp
  copy_benchmark.cpp
  simd_ampmod_benchmarks.cpp
  simd_mix_benchmark.cpp
  simd_pan2_benchmark.cpp
  simd_peakmeter_benchmarks.cpp
  simd_plus_benchmarks.cpp
  simd_pow_benchmarks.cpp
  simd_slope_benchmarks.cpp
  simd_softclip_benchmarks.cpp
  simd_tan_benchmarks.cpp
  simd_tanh_benchmarks.cpp
  simd_unroll_benchmarks2.cpp
  simd_unroll_benchmarks.cpp
)

# build benchmarks
foreach(benchmark ${benchmarks})
  string(REPLACE .cpp "" benchmark_name ${benchmark} )
  add_executable(${benchmark_name} ${benchmark})
endforeach(benchmark)

=== common/include/nova-simd/libsimdmath/lib/Makefile ===
ifeq ($(PROCESSOR),PPU)
	CC     :=  gcc
	AR     :=  ar -r
	CFLAGS :=  -D__PPU__ -mabi=altivec -maltivec 
	CFLAGS +=  --param max-inline-insns-single=1200 -Winline
else
# PROCESSOR must be one of SSE, PPU, or SPU

ifeq ($(PROCESSOR),SPU)
	CC     :=  spu-gcc
	AR     :=  spu-ar -r
	CFLAGS :=  --param max-inline-insns-single=1200 -Winline
else
ifeq ($(PROCESSOR),SSE)
	CC     :=  gcc
	AR     :=  ar -r
	CFLAGS :=  -msse3
endif
endif
endif

Header := asinf4.h atanf4.h expf4.h fabsf4.h floorf4.h  logf4.h \
	  powf4.h simdconst.h simdmath.h sincosf4.h sqrtf4.h


lib:	Makefile math.c   $(Header)
	$(CC) $(CFLAGS) -O3 -c math.c
	$(AR) libsimdmath.a math.o


clean:	
	rm -rf *.o libsimdmath.a

=== common/include/nova-simd/libsimdmath/tests/Makefile ===
# PROCESSOR must be one of SSE, PPU, or SPU

ifeq ($(PROCESSOR),PPU)
	CC     :=  gcc
	AR     :=  ar -r
	CFLAGS :=  -D__PPU__ -mabi=altivec -maltivec 
	CFLAGS +=  --param max-inline-insns-single=1200 -Winline
else
ifeq ($(PROCESSOR),SPU)
	CC     :=  spu-gcc
	AR     :=  spu-ar -r
	CFLAGS :=  --param max-inline-insns-single=1200 -Winline
else
ifeq ($(PROCESSOR),SSE)
	CC     :=  gcc
	AR     :=  ar -r
	CFLAGS :=  -msse3
endif
endif
endif

CFLAGS += -I../lib

LIBSM  := ../lib/libsimdmath.a

Header := asinf4.h atanf4.h expf4.h fabsf4.h floorf4.h  logf4.h \
	  powf4.h ../lib/simdconst.h ../lib/simdmath.h sincosf4.h sqrtf4.h


test:	Makefile simdtest.c $(LIBSM)
	$(CC) $(CFLAGS) -DLIBSIMD  simdtest.c -lm $(LIBSM) -o test

tlibm:	Makefile simdtest.c stdmath.c
	$(CC) $(CFLAGS) -O3  -c stdmath.c
	$(CC) $(CFLAGS) -DLIBMATH  stdmath.o simdtest.c -lm -o tlibm

tps3m:	Makefile simdtest.c ps3math.c
	$(CC) $(CFLAGS) -I/usr/lib/gcc/ppu/4.1.1/include -O3  -c ps3math.c
	$(CC) $(CFLAGS)  -DCELL  ps3math.o simdtest.c -lm -o tps3m

tveclib:	Makefile simdtest.c	
	$(CC) $(CFLAGS)  -DMACVEC -framework accelerate simdtest.c -o tveclib


clean:
	rm -rf *.o test tlibm tps3m tveclib

=== debian/changelog ===
supercollider (1:3.4.5-1wheezy1) testing; urgency=low

  [ Dan Stowell ]
  * Update rules to set DEB_SRCDIR. Closes #674386

  [ Felipe Sateler ]
  * Build with gcc 4.6 to avoid an internal compiler error with 4.7

 -- Felipe Sateler <fsateler@debian.org>  Wed, 15 Aug 2012 18:20:51 -0400

supercollider (1:3.4.5-1) unstable; urgency=low

  [ Dan Stowell ]
  * Imported Upstream version 3.4.5
  * remove debian patches 11 & 12, upstreamed

 -- Dan Stowell <danstowell@users.sourceforge.net>  Sun, 15 Jan 2012 15:48:04 +0000

supercollider (1:3.4.4-3) unstable; urgency=low

  * Patch from Mathieu Trudel-Lapierre to fix build under stricter linking.
    Closes: #648782

 -- Dan Stowell <danstowell@users.sourceforge.net>  Tue, 15 Nov 2011 09:54:00 +0000

=== debian/control ===
Source: supercollider
Section: sound
Priority: optional
Vcs-Git: git://git.debian.org/pkg-multimedia/supercollider.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/supercollider.git;a=summary
Maintainer: Debian Multimedia Packages Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Quessy <alexandre@quessy.net>,
 Felipe Sateler <fsateler@debian.org>,
 Dan Stowell <danstowell@users.sourceforge.net>
Build-Depends: 
 cdbs (>= 0.4.73~),
 debhelper (>= 6),
 libasound2-dev [linux-any],
 libavahi-client-dev,
 libcwiid-dev,
 libfftw3-dev,
 libicu-dev,
 libjack-dev,
 libreadline-dev,
 libsndfile1-dev (>= 1.0.16),
 libxt-dev,
 python-all-dev (>= 2.6.6-3~),
 scons (>= 0.96),
 gcc-4.6,
 g++-4.6
Standards-Version: 3.9.2
Homepage: http://supercollider.sourceforge.net/

Package: supercollider
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
  supercollider-common (= ${source:Version}),
  supercollider-server
Suggests: subversion, supercollider-doc
Description: real time audio synthesis programming language
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the language interpreter.

Package: libsclang1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SuperCollider language interpreter library
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the shared library for the language interpreter.

Package: supercollider-common
Architecture: all
Depends: ${misc:Depends}
Description: common files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the architecture independent files for SuperCollider.

Package: supercollider-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jackd
Description: real time audio synthesis server
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the synthesis server.

Package: libscsynth1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SuperCollider synthesis server library
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the shared library for the synthesis server.

Package: supercollider-dev
Architecture: any
Depends: ${misc:Depends},
  supercollider (= ${binary:Version}),
  libsndfile1-dev (>= 1.0.16)
Conflicts: supercollider-common-dev, supercollider-server-dev
Replaces: supercollider-common-dev, supercollider-server-dev
Provides: supercollider-common-dev, supercollider-server-dev
Description: development files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the development files and headers.

Package: supercollider-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: supercollider
Description: documentation for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the HTML documentation for SuperCollider.

Package: supercollider-emacs
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}),
  emacs23 | emacsen
Recommends: supercollider-doc, w3m-el
Description: SuperCollider mode for Emacs
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Emacs.
 .
 Package supercollider-doc is suggested so that the editor can show help
 documentation in context.

Package: supercollider-vim
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}), vim | gvim, ruby
Recommends: supercollider-doc, unhtml | links, vim-addon-manager
Suggests: unrtf
Description: SuperCollider mode for Vim
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Vim.
 .
 Package supercollider-doc is suggested so that the editor can show help
 documentation in context.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/scons.mk

DEB_SRCDIR=common

# Add here any variable or target overrides you need.
DEB_DH_INSTALL_SOURCEDIR=debian/tmp
export CDBS_NO_DOC_SYMLINKING:=1

# G++ 4.7 ICEs, so use 4.6
CC=gcc-4.6
CXX=g++-4.6

# Do not enable parallel building: scons cannot handle parallel
# builds when the chdir option is used in any command
# DEB_BUILD_PARALLEL = 1

DEB_INSTALL_DOCS_supercollider             = "README LINUX" common/build/README
DEB_INSTALL_DOCS_supercollider-server      = "README LINUX" common/build/README
DEB_INSTALL_DOCS_supercollider-emacs       = editors/scel/README
DEB_INSTALL_DOCS_supercollider-vim         = editors/scvim/README editors/scvim/SCVim.scd
DEB_INSTALL_CHANGELOGS_ALL                 = common/build/ChangeLog

DEB_INSTALL_MANPAGES_supercollider-server  = debian/scsynth.1
DEB_INSTALL_MANPAGES_supercollider         = debian/sclang.1
DEB_INSTALL_MANPAGES_supercollider-vim     = debian/scvim.1 debian/scvim_make_help.1 debian/sclangpipe_app.1

# recent SVN revisions also install examples to $(DEB_DESTDIR)/usr/share
DEB_INSTALL_EXAMPLES_supercollider         = common/build/examples/*
DEB_INSTALL_DIRS_supercollider             = usr/share/SuperCollider/Extensions

# SCVIM/SCED=0 here, because we install them by hand below
# (so that the build won't break)
# Also STRIP=0 since we let cdbs (dh_strip) decide whether to strip
DEB_SCONS_OPTIONS = DEVELOPMENT=yes PREFIX=/usr CROSSCOMPILE=1 CURL=0 SCVIM=0 SCED=0 STRIP=0
# Handle DEB_BUILD_OPTIONS (see policy 4.9.1)
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS += "DEBUG=1"
endif

DEB_SCONS_INSTALL_TARGET = DESTDIR=$(DEB_DESTDIR) install

# The build system apparently can't handle this
CXXFLAGS =

clean:: scons-clean
scons-clean::
	dh_testdir
	scons -C common $(SCONS_FLAGS) --clean scrub
	rm -f common/.sconsign.dblite
	rm -f editors/scvim/.sconsign.dblite
	rm -f editors/sced/.sconsign.dblite
	# also remove some files, that SCons forgets about
	rm -f editors/scel/el/sclang-vars.el
	rm -f linux/libsclang.pc
	rm -f linux/libscplugin.pc
	rm -f linux/libscsynth.pc

common-install-arch common-install-indep:: common-install-impl
common-install-impl::
	scons --install-sandbox=$(DEB_DESTDIR) --directory=editors/scvim PREFIX=/usr VIMFILE_DIR=/usr/share/vim/addons install-all
	scons --install-sandbox=$(DEB_DESTDIR) --directory=editors/sced PREFIX=/usr install
	# fixing some executables in class library and docs for happier lintian
	find $(DEB_DESTDIR)/usr/share/SuperCollider -type d -exec chmod 755 {} \;; \
	find $(DEB_DESTDIR)/usr/share/SuperCollider -type f -exec chmod 644 {} \;; \
	# vim-addon-manager stuff
	install -d $(DEB_DESTDIR)/usr/share/vim/registry
	install -m 644 debian/supercollider-vim.yaml $(DEB_DESTDIR)/usr/share/vim/registry
	# lintian overrides
	install -m 644 debian/README.extensions $(DEB_DESTDIR)/usr/share/SuperCollider/Extensions/README
	# icons and metadata for freedesktop-style menu entries
	install -d $(DEB_DESTDIR)/usr/share/applications
	install -m 644 debian/*.desktop $(DEB_DESTDIR)/usr/share/applications
	install -d $(DEB_DESTDIR)/usr/share/pixmaps
	install -m 644 linux/icons/supercollider.xpm $(DEB_DESTDIR)/usr/share/pixmaps
	install -m 644 linux/icons/supercollider.png $(DEB_DESTDIR)/usr/share/pixmaps
